#pragma once

/******************************************************************************************************************************************
 * INCLUDES
 *****************************************************************************************************************************************/
#include <stdint.h>
#include "mem1.h"

/******************************************************************************************************************************************
 * DEFINES
 *****************************************************************************************************************************************/

/******************************************************************************************************************************************
 * FUNCTION DECLARATIONS
 *****************************************************************************************************************************************/

#if defined ( MEM1_TEST_MODE )
/****************
 * Test cases
 ****************/
void mem1test_FullHeapAlloc(void);
void mem1test_FullHeapAllocInSecondRequest(void);
void mem1test_FullHeapAllocInSecondRequest_FreeReversedOrder(void);
void mem1test_AllocRequestSizeTooLarge(void);
void mem1test_FreeBasic(void);
void mem1test_FreeLatestToFirst(void);
void mem1test_FreeFirstToLatest(void);
void mem1test_FreeMiddlePrevious(void);
void mem1test_FreeMiddleNext(void);
void mem1test_FreeMiddleTwoPrevious(void);
void mem1test_FreeMiddleTwoNext(void);
void mem1test_FreeMiddleAllocateAgain(void);
void mem1test_ReallocLargerSize(void);
void mem1test_ReallocSmallerSize(void);
#endif

